Index: uspace/srv/hid/output/port/ski.c
===================================================================
--- uspace/srv/hid/output/port/ski.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/srv/hid/output/port/ski.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,111 @@
+/*
+ * Copyright (c) 2006 Ondrej Palkovsky
+ * Copyright (c) 2008 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#include <sys/types.h>
+#include <errno.h>
+#include <sysinfo.h>
+#include "../ctl/serial.h"
+#include "ski.h"
+
+#ifdef UARCH_ia64
+
+#define SKI_PUTCHAR  31
+
+/** Display character on ski debug console
+ *
+ * Use SSC (Simulator System Call) to
+ * display character on debug console.
+ *
+ * @param c Character to be printed.
+ *
+ */
+static void ski_putc(const char c)
+{
+	asm volatile (
+		"mov r15 = %0\n"
+		"mov r32 = %1\n"   /* r32 is in0 */
+		"break 0x80000\n"  /* modifies r8 */
+		:
+		: "i" (SKI_PUTCHAR), "r" (c)
+		: "r15", "in0", "r8"
+	);
+	
+	if (c == '\n')
+		ski_putc('\r');
+}
+
+static void ski_putchar(wchar_t ch)
+{
+	if ((ch >= 0) && (ch < 128))
+		ski_putc(ch);
+	else
+		ski_putc('?');
+}
+
+static void ski_control_puts(const char *str)
+{
+	while (*str)
+		ski_putc(*(str++));
+}
+
+int ski_init(void)
+{
+	sysarg_t present;
+	int rc = sysinfo_get_value("fb", &present);
+	if (rc != EOK)
+		present = false;
+	
+	if (!present)
+		return ENOENT;
+	
+	sysarg_t kind;
+	rc = sysinfo_get_value("fb.kind", &kind);
+	if (rc != EOK)
+		kind = (sysarg_t) -1;
+	
+	if (kind != 6)
+		return EINVAL;
+	
+	return serial_init(ski_putchar, ski_control_puts);
+}
+
+#else /* UARCH_ia64 */
+
+int ski_init(void)
+{
+	return ENOENT;
+}
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/output/port/ski.h
===================================================================
--- uspace/srv/hid/output/port/ski.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/srv/hid/output/port/ski.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,44 @@
+/*
+ * Copyright (c) 2008 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup console
+ * @{
+ */
+/**
+ * @file
+ */
+
+#ifndef OUTPUT_PORT_SKI_H_
+#define OUTPUT_PORT_SKI_H_
+
+extern int ski_init(void);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,232 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#include <sys/types.h>
+#include <inttypes.h>
+#include <errno.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <malloc.h>
+#include <io/color.h>
+#include "vt100.h"
+
+#define MAX_CONTROL  20
+
+typedef enum {
+	CI_BLACK   = 0,
+	CI_RED     = 1,
+	CI_GREEN   = 2,
+	CI_BROWN   = 3,
+	CI_BLUE    = 4,
+	CI_MAGENTA = 5,
+	CI_CYAN    = 6,
+	CI_WHITE   = 7
+} sgr_color_index_t;
+
+typedef enum {
+	SGR_RESET       = 0,
+	SGR_BOLD        = 1,
+	SGR_UNDERLINE   = 4,
+	SGR_BLINK       = 5,
+	SGR_REVERSE     = 7,
+	SGR_FGCOLOR     = 30,
+	SGR_BGCOLOR     = 40
+} sgr_command_t;
+
+static sgr_color_index_t color_map[] = {
+	[COLOR_BLACK]   = CI_BLACK,
+	[COLOR_BLUE]    = CI_RED,
+	[COLOR_GREEN]   = CI_GREEN,
+	[COLOR_CYAN]    = CI_CYAN,
+	[COLOR_RED]     = CI_RED,
+	[COLOR_MAGENTA] = CI_MAGENTA,
+	[COLOR_YELLOW]  = CI_BROWN,
+	[COLOR_WHITE]   = CI_WHITE
+};
+
+/** ECMA-48 Set Graphics Rendition. */
+static void vt100_sgr(vt100_state_t *state, unsigned int mode)
+{
+	char control[MAX_CONTROL];
+	
+	snprintf(control, MAX_CONTROL, "\033[%um", mode);
+	state->control_puts(control);
+}
+
+static void vt100_set_pos(vt100_state_t *state, sysarg_t col, sysarg_t row)
+{
+	char control[MAX_CONTROL];
+	
+	snprintf(control, MAX_CONTROL, "\033[%" PRIun ";%" PRIun "f",
+	    row + 1, col + 1);
+	state->control_puts(control);
+}
+
+static void vt100_set_sgr(vt100_state_t *state, char_attrs_t attrs)
+{
+	switch (attrs.type) {
+	case CHAR_ATTR_STYLE:
+		switch (attrs.val.style) {
+		case STYLE_NORMAL:
+			vt100_sgr(state, SGR_RESET);
+			vt100_sgr(state, SGR_BGCOLOR + CI_WHITE);
+			vt100_sgr(state, SGR_FGCOLOR + CI_BLACK);
+			break;
+		case STYLE_EMPHASIS:
+			vt100_sgr(state, SGR_RESET);
+			vt100_sgr(state, SGR_BGCOLOR + CI_WHITE);
+			vt100_sgr(state, SGR_FGCOLOR + CI_RED);
+			vt100_sgr(state, SGR_BOLD);
+			break;
+		case STYLE_INVERTED:
+			vt100_sgr(state, SGR_RESET);
+			vt100_sgr(state, SGR_BGCOLOR + CI_BLACK);
+			vt100_sgr(state, SGR_FGCOLOR + CI_WHITE);
+			break;
+		case STYLE_SELECTED:
+			vt100_sgr(state, SGR_RESET);
+			vt100_sgr(state, SGR_BGCOLOR + CI_RED);
+			vt100_sgr(state, SGR_FGCOLOR + CI_WHITE);
+			break;
+		}
+		break;
+	case CHAR_ATTR_INDEX:
+		vt100_sgr(state, SGR_RESET);
+		vt100_sgr(state, SGR_BGCOLOR + color_map[attrs.val.index.bgcolor & 7]);
+		vt100_sgr(state, SGR_FGCOLOR + color_map[attrs.val.index.fgcolor & 7]);
+		
+		if (attrs.val.index.attr & CATTR_BRIGHT)
+			vt100_sgr(state, SGR_BOLD);
+		
+		break;
+	case CHAR_ATTR_RGB:
+		vt100_sgr(state, SGR_RESET);
+		
+		if (attrs.val.rgb.bgcolor <= attrs.val.rgb.fgcolor)
+			vt100_sgr(state, SGR_REVERSE);
+		
+		break;
+	}
+}
+
+vt100_state_t *vt100_state_create(sysarg_t cols, sysarg_t rows,
+    vt100_putchar_t putchar_fn, vt100_control_puts_t control_puts_fn)
+{
+	vt100_state_t *state =
+	    malloc(sizeof(vt100_state_t));
+	if (state == NULL)
+		return NULL;
+	
+	state->putchar = putchar_fn;
+	state->control_puts = control_puts_fn;
+	
+	state->cols = cols;
+	state->rows = rows;
+	
+	state->cur_col = (sysarg_t) -1;
+	state->cur_row = (sysarg_t) -1;
+	
+	state->cur_attrs.type = CHAR_ATTR_STYLE;
+	state->cur_attrs.val.style = STYLE_NORMAL;
+	
+	/* Initialize graphic rendition attributes */
+	vt100_sgr(state, SGR_RESET);
+	vt100_sgr(state, SGR_FGCOLOR + CI_BLACK);
+	vt100_sgr(state, SGR_BGCOLOR + CI_WHITE);
+	state->control_puts("\033[2J");
+	state->control_puts("\033[?25l");
+	
+	return state;
+}
+
+void vt100_state_destroy(vt100_state_t *state)
+{
+	free(state);
+}
+
+void vt100_get_dimensions(vt100_state_t *state, sysarg_t *cols,
+    sysarg_t *rows)
+{
+	*cols = state->cols;
+	*rows = state->rows;
+}
+
+int vt100_yield(vt100_state_t *state)
+{
+	return EOK;
+}
+
+int vt100_claim(vt100_state_t *state)
+{
+	return EOK;
+}
+
+void vt100_goto(vt100_state_t *state, sysarg_t col, sysarg_t row)
+{
+	if ((col >= state->cols) || (row >= state->rows))
+		return;
+	
+	if ((col != state->cur_col) || (row != state->cur_row)) {
+		vt100_set_pos(state, col, row);
+		state->cur_col = col;
+		state->cur_row = row;
+	}
+}
+
+void vt100_set_attr(vt100_state_t *state, char_attrs_t attrs)
+{
+	if (!attrs_same(state->cur_attrs, attrs)) {
+		vt100_set_sgr(state, attrs);
+		state->cur_attrs = attrs;
+	}
+}
+
+void vt100_cursor_visibility(vt100_state_t *state, bool visible)
+{
+	if (visible)
+		state->control_puts("\033[?25h");
+	else
+		state->control_puts("\033[?25l");
+}
+
+void vt100_putchar(vt100_state_t *state, wchar_t ch)
+{
+	state->putchar(ch == 0 ? ' ' : ch);
+	state->cur_col++;
+	
+	if (state->cur_col >= state->cols) {
+		state->cur_row += state->cur_col / state->cols;
+		state->cur_col %= state->cols;
+	}
+}
+
+/** @}
+ */
Index: uspace/srv/hid/output/proto/vt100.h
===================================================================
--- uspace/srv/hid/output/proto/vt100.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
+++ uspace/srv/hid/output/proto/vt100.h	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2011 Martin Decky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @file
+ */
+
+#ifndef OUTPUT_PROTO_VT100_H_
+#define OUTPUT_PROTO_VT100_H_
+
+#include <sys/types.h>
+#include <io/charfield.h>
+
+typedef void (* vt100_putchar_t)(wchar_t ch);
+typedef void (* vt100_control_puts_t)(const char *str);
+
+typedef struct {
+	sysarg_t cols;
+	sysarg_t rows;
+	
+	sysarg_t cur_col;
+	sysarg_t cur_row;
+	char_attrs_t cur_attrs;
+	
+	vt100_putchar_t putchar;
+	vt100_control_puts_t control_puts;
+} vt100_state_t;
+
+extern vt100_state_t *vt100_state_create(sysarg_t, sysarg_t, vt100_putchar_t,
+    vt100_control_puts_t);
+extern void vt100_state_destroy(vt100_state_t *);
+
+extern int vt100_yield(vt100_state_t *);
+extern int vt100_claim(vt100_state_t *);
+extern void vt100_get_dimensions(vt100_state_t *, sysarg_t *, sysarg_t *);
+
+extern void vt100_goto(vt100_state_t *, sysarg_t, sysarg_t);
+extern void vt100_set_attr(vt100_state_t *, char_attrs_t);
+extern void vt100_cursor_visibility(vt100_state_t *, bool);
+extern void vt100_putchar(vt100_state_t *, wchar_t);
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/hid/remcons/remcons.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -363,4 +363,5 @@
 
 	printf("%s: HelenOS Remote console service\n", NAME);
+	task_retval(0);
 
 	while (true) {
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision f3a37e28da7ac61dc36eddfe4c920641264b4500)
+++ uspace/srv/locsrv/locsrv.c	(revision 7eaeec113ff74c8737354abec7d5185097de8278)
@@ -1367,4 +1367,10 @@
 	cat = category_new("nic");
 	categ_dir_add_cat(&cdir, cat);
+
+	cat = category_new("visualizer");
+	categ_dir_add_cat(&cdir, cat);
+
+	cat = category_new("renderer");
+	categ_dir_add_cat(&cdir, cat);
 	
 	return true;
